#include "efi.h"
#include "efilib.h"


#include "UseDrv.h"
#include "SiSmDriver.h"

EFI_SYSTEM_TABLE 	*gSysTable = NULL;

//---------------------------------------------------------------------------
// Name:	UseDrvEntryPoint
//
//---------------------------------------------------------------------------
EFI_STATUS
EFIAPI
UseDrvEntryPoint (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  )
{
	EFI_STATUS              Status = EFI_SUCCESS;
	EFI_INPUT_KEY		NewKey;
	EFI_SISM_IO_PROTOCOL 	*SiSmDriverProtocol;
	EFI_GUID 		gEfiSiSmIoProtocolGuid 		= EFI_SISM_IO_PROTOCOL_GUID;
	UINTN			Drv_Status=0;//0: not loaded

  	// Initialize the EFI UseDrvApp library
//  	InitAmiLib(ImageHandle, SystemTable);
	InitializeLib(ImageHandle, SystemTable);//EDKII

	// Initialize global variable for use in this driver
    	gSysTable = SystemTable;

        gSysTable->ConOut->ClearScreen (gSysTable->ConOut);
  	gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 5, 1);

        gSysTable->ConOut->OutputString(gSysTable->ConOut, L"============== Start ======= (Use please:2/1/0/q/l/u) =======\n\r" );
        gSysTable->ConOut->OutputString(gSysTable->ConOut, L"           SiSm Load/Unload/Use Driver. 24.10.11\n\r" );
  	gSysTable->ConOut->SetAttribute (gSysTable->ConOut, EFI_RED );
        gSysTable->ConOut->EnableCursor (gSysTable->ConOut, FALSE);

	Status = gSysTable->BootServices->LocateProtocol (&gEfiSiSmIoProtocolGuid, NULL, &SiSmDriverProtocol);

	if (!EFI_ERROR (Status)) {
		Drv_Status=1;
		SiSmDriverProtocol->SiSmIoSetValueOn();
	}
	else {
		Drv_Status=0;
        	gSysTable->ConOut->OutputString(gSysTable->ConOut, L"=========== Error: Driver is not loaded ============\n" );
	}


        gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 1, 10);
        gSysTable->ConOut->OutputString (gSysTable->ConOut, L"Value Start: 1");

	do
	{
	Status = gSysTable->ConIn->ReadKeyStroke( gSysTable->ConIn, &NewKey );

        if(NewKey.UnicodeChar == L'1')
		if( Drv_Status == 1 ){
                 gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 1, 10);
                 gSysTable->ConOut->OutputString (gSysTable->ConOut, L"Value Start    : 1");
		 SiSmDriverProtocol->SiSmIoSetValueOn();
                 }
        if(NewKey.UnicodeChar == L'0')
		if( Drv_Status == 1 ){
                 gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 1, 10);
                 gSysTable->ConOut->OutputString (gSysTable->ConOut, L"Value Stop     : 0 ");
		 SiSmDriverProtocol->SiSmIoSetValueOff();
                 }
        if(NewKey.UnicodeChar == L'2')
		if( Drv_Status == 1 ){
                 gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 1, 10);
                 gSysTable->ConOut->OutputString (gSysTable->ConOut, L"Value Decrement: 2");
		 SiSmDriverProtocol->SiSmIoSetValueDec();
                 }
        if(NewKey.UnicodeChar == L'l')
		if( Drv_Status == 0 ){
                 	gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 1, 10);
                 	gSysTable->ConOut->OutputString (gSysTable->ConOut, L"Load Driver !     ");
		 	//SiSmDriverProtocol->SiSmIoSetValueDec();
		 	Drv_Status = 1;

			//
			// Invoke OemResetSystem, if gEfiOemResetProtocolGuid is installed.
			//
			Status = gSysTable->BootServices->LocateProtocol (&gEfiSiSmIoProtocolGuid, NULL, &SiSmDriverProtocol);
	
			if (!EFI_ERROR (Status)) {
				SiSmDriverProtocol->SiSmIoSetValueOn();
			}
			else {
				Drv_Status=0;
		        	gSysTable->ConOut->OutputString(gSysTable->ConOut, L"=========== Error: Driver is not loaded ============\n" );
				//return EFI_SUCCESS;
			}
                 }
        if(NewKey.UnicodeChar == L'u')
		if( Drv_Status == 1 ){
                 gSysTable->ConOut->SetCursorPosition (gSysTable->ConOut, 1, 10);
                 gSysTable->ConOut->OutputString (gSysTable->ConOut, L"Unload Driver !   ");
		 //SiSmDriverProtocol->SiSmIoSetValueDec();
		 Drv_Status = 0;
                 }
	}
	while( ( NewKey.UnicodeChar != L'q') &&
		   ( NewKey.ScanCode != 0x17 )	); 

	gSysTable->ConOut->ClearScreen (gSysTable->ConOut);
	gSysTable->ConOut->SetAttribute (gSysTable->ConOut, EFI_YELLOW | EFI_BRIGHT);
	gSysTable->ConOut->EnableCursor (gSysTable->ConOut, FALSE);
	//SiSmDriverProtocol->SiSmIoSetValueOff();

        gSysTable->ConOut->OutputString(gSysTable->ConOut, L"=========== Ende =======================\n" );

  	return Status;
}



